import { UsersService } from "../../services/UsersService";
import { IUser } from "../../models/User";
export declare class UserCtrl {
    private usersService;
    constructor(usersService: UsersService);
    /**
     * Authenticate a user.
     * @param email
     * @param password
     * @returns {IUser}
     */
    authenticate(email: string, password: string): IUser;
    /**
     * Find a user by is mail or id.
     * @param idOrMail
     * @returns {IUser}
     */
    get(idOrMail: string): IUser;
    updateStatus(email: string, status: string): IUser;
    /**
     *
     * @param id
     * @param user
     * @returns {IUser}
     */
    update(id: string, user: any): IUser;
    /**
     *
     * @param user
     * @returns {IUser}
     */
    create(user: IUser): IUser;
    /**
     * Remove the user.
     * @param id
     * @returns {any}
     */
    remove(id: string): IUser;
    /**
     * Get All users.
     * @returns {IUser[]}
     */
    getList(): IUser[];
}
