"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_express_decorators_1 = require("ts-express-decorators");
var SocketIO = require("socket.io");
var SocketService = (function () {
    function SocketService() {
        var _this = this;
        this.stacks = [];
        this.emit = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return (_a = _this.io).emit.apply(_a, args);
            var _a;
        };
    }
    /**
     * Store all callbacks that will be adding to socket.io instance when
     *  it"ll be created. See SocketService.createServer().
     */
    SocketService.prototype.onConnection = function (callback) {
        this.stacks.push(callback);
        return this;
    };
    SocketService.prototype.createServer = function (httpServer) {
        var _this = this;
        this.io = SocketIO(httpServer);
        // Map all callbacks to this connection events.
        this.stacks.forEach(function (cb) { return _this.io.on("connection", cb); });
    };
    return SocketService;
}());
SocketService = __decorate([
    ts_express_decorators_1.Service(),
    __metadata("design:paramtypes", [])
], SocketService);
exports.SocketService = SocketService;
//# sourceMappingURL=SocketService.js.map