import { IUser, PartialUser } from "../models/User";
import { SocketService } from "./SocketService";
export declare class UsersService {
    private socketService;
    private USERS;
    private users;
    constructor(socketService: SocketService);
    /**
     *
     * @param email
     * @returns {boolean}
     */
    checkEmail(email: string): boolean;
    /**
     *
     * @param status
     * @returns {boolean}
     */
    checkStatus(status: string): boolean;
    /**
     * Find a user by his ID.
     * @param id
     * @returns {undefined|IUser}
     */
    find(id: string): IUser;
    findByEmail(email: string): IUser;
    findByCredential(email: string, password: string): IUser;
    /**
     * Create a new User
     * @returns {{id: any, name: string}}
     * @param user
     */
    create(user: IUser): IUser;
    /**
     *
     * @returns {IUser[]}
     */
    query(): IUser[];
    /**
     *
     * @param id
     * @param user
     * @returns {IUser}
     */
    update(id: string, user: IUser | PartialUser): IUser;
    remove(id: string): void;
}
