"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_log_debug_1 = require("ts-log-debug");
var ts_express_decorators_1 = require("ts-express-decorators");
var Path = require("path");
var SocketService_1 = require("./services/SocketService");
var ts_json_properties_1 = require("ts-json-properties");
var rootDir = Path.resolve(__dirname);
var Server = (function (_super) {
    __extends(Server, _super);
    function Server() {
        var _this = _super.call(this) || this;
        ts_json_properties_1.Properties.initialize(rootDir + "/../properties.json");
        return _this;
    }
    /**
     * This method let you configure the middleware required by your application to works.
     * @returns {Server}
     */
    Server.prototype.$onMountingMiddlewares = function () {
        var morgan = require('morgan'), cookieParser = require('cookie-parser'), bodyParser = require('body-parser'), compress = require('compression'), methodOverride = require('method-override');
        this
            .use(morgan('dev'))
            .use(ts_express_decorators_1.GlobalAcceptMimesMiddleware)
            .use(cookieParser())
            .use(compress({}))
            .use(methodOverride())
            .use(bodyParser.json())
            .use(bodyParser.urlencoded({
            extended: true
        }));
        this.engine('.html', require('ejs').__express)
            .set('views', __dirname + "/../views")
            .set('view engine', 'html');
        return null;
    };
    Server.prototype.$onReady = function (socketService) {
        ts_log_debug_1.$log.debug('Server initialized');
        socketService.createServer(this.httpServer);
    };
    Server.prototype.$onServerInitError = function (error) {
        ts_log_debug_1.$log.error('Server encounter an error =>', error);
    };
    return Server;
}(ts_express_decorators_1.ServerLoader));
__decorate([
    ts_express_decorators_1.Inject(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [SocketService_1.default]),
    __metadata("design:returntype", void 0)
], Server.prototype, "$onReady", null);
Server = __decorate([
    ts_express_decorators_1.ServerSettings({
        rootDir: rootDir,
        mount: {
            '/api': rootDir + "/controllers/**/**.js"
        },
        acceptMimes: ["application/json"]
    }),
    __metadata("design:paramtypes", [])
], Server);
exports.Server = Server;
//# sourceMappingURL=index.js.map