import { IUser } from "../models/User";
export declare class UsersService {
    users: any[];
    /**
     * Find a user by his ID.
     * @param id
     * @returns {undefined|IUser}
     */
    find(id: string): IUser;
    findByEmail(email: string): IUser;
    findByCredential(email: string, password: string): IUser;
    /**
     * Create a new User
     * @param name
     * @returns {{id: any, name: string}}
     */
    create(user: IUser): IUser;
    /**
     *
     * @returns {IUser[]}
     */
    query(): IUser[];
    /**
     *
     * @param user
     * @returns {IUser}
     */
    update(user: IUser): IUser;
    /**
     *
     * @param user
     * @returns {IUser}
     */
    patch(user: IUser): IUser;
}
