"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_json_properties_1 = require("ts-json-properties");
var ts_express_decorators_1 = require("ts-express-decorators");
var UsersService = (function () {
    function UsersService() {
    }
    /**
     * Find a user by his ID.
     * @param id
     * @returns {undefined|IUser}
     */
    UsersService.prototype.find = function (id) {
        var users = this.query();
        return users.find(function (value) { return value._id === id; });
    };
    UsersService.prototype.findByEmail = function (email) {
        var users = this.query();
        return users.find(function (value) { return value.email === email; });
    };
    UsersService.prototype.findByCredential = function (email, password) {
        var users = this.query();
        return users.find(function (value) { return value.email === email && value.password === password; });
    };
    /**
     * Create a new User
     * @param name
     * @returns {{id: any, name: string}}
     */
    UsersService.prototype.create = function (user) {
        user._id = require('node-uuid').v4();
        this.users.push(user);
        return user;
    };
    /**
     *
     * @returns {IUser[]}
     */
    UsersService.prototype.query = function () {
        return this.users;
    };
    /**
     *
     * @param user
     * @returns {IUser}
     */
    UsersService.prototype.update = function (user) {
        var users = this.query();
        var index = this.users.find(function (o) { return user._id === o._id; });
        users[index] = user;
        return user;
    };
    /**
     *
     * @param user
     * @returns {IUser}
     */
    UsersService.prototype.patch = function (user) {
        var users = this.query();
        var index = this.users.find(function (o) { return user._id === o._id; });
        users[index] = Object.assign(users[index], user);
        return users[index];
    };
    return UsersService;
}());
__decorate([
    ts_json_properties_1.Value("users.list"),
    __metadata("design:type", Array)
], UsersService.prototype, "users", void 0);
UsersService = __decorate([
    ts_express_decorators_1.Service()
], UsersService);
exports.UsersService = UsersService;
//# sourceMappingURL=UsersService.js.map